package com.example.mynotepad.MenuFeatures.AllNotes.DataBase;

import android.content.Context;

import androidx.room.Database;
import androidx.room.Room;
import androidx.room.RoomDatabase;
import androidx.room.TypeConverters;

@Database(entities = {Note.class, DateEntity.class ,PicsEntity.class , FoldersEntity.class},version = 1)
@TypeConverters({Converters.class})
public abstract class NoteDataBase extends RoomDatabase {

    private static NoteDataBase instance;

    public abstract NoteDAO noteDao();
    public abstract DateNoreDAO dateNoreDAO();
    public abstract PicsDao picsDao();
    public abstract FoldersDAO foldersDAO();

    public static NoteDataBase getInstance(Context context) {
        if (instance == null)
            instance = Room.databaseBuilder(context, NoteDataBase.class, "RoomDb")
                    .fallbackToDestructiveMigration()
                    .allowMainThreadQueries() // this code may block the main thread, every database transaction must be executed on background thread no
                    .build();// as long as this method is called no, if you remove this method then you should call every single method of your DAOs on a background thread
        return instance;
    }
}
