package com.example.mynotepad.MenuFeatures.Folders;


import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.FrameLayout;
import com.example.mynotepad.Dialogs.FoldersCustomDialog.FolderRecyclerViewAdapter;
import com.example.mynotepad.MainActivity;;
import com.example.mynotepad.MenuFeatures.AllNotes.DataBase.NoteDataBase;
import com.example.mynotepad.MenuFeatures.CustomToolbarOption;
import com.example.mynotepad.MenuFeatures.Utils;
import com.example.mynotepad.R;


public class FoldersListFragment extends Fragment {

    private FolderRecyclerViewAdapter folderRecyclerViewAdapter;
    private RecyclerView recyclerView;
    private CustomToolbarOption customToolbarOption;
    private FrameLayout allNoteToolBar;
    private View listLayout;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        return inflater.inflate(R.layout.fragment_foldersl_list, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        init(view);
        setBg(Utils.sTheme);

    }

    private void setBg(String sTheme) {
        switch (sTheme) {
            case "dark":
                listLayout.setBackgroundResource(R.drawable.main_bg_dark);
                break;
            case "bright":
                listLayout.setBackgroundResource(R.drawable.main_bg_bright);
                break;
        }
    }

    private void init(View view) {
        listLayout = view.findViewById(R.id.allNoteListLayout);
        recyclerView = view.findViewById(R.id.recyclerView);
        customToolbarOption = view.findViewById(R.id.customToolbarOption);
        customToolbarOption.setVisibility(View.GONE);
        allNoteToolBar = view.findViewById(R.id.toolbar);
        allNoteToolBar.setEnabled(false);
        folderRecyclerViewAdapter = new FolderRecyclerViewAdapter(NoteDataBase.getInstance(getContext()).foldersDAO().getAllFolders(), getActivity());
        recyclerView.setAdapter(folderRecyclerViewAdapter);
        recyclerView.setLayoutManager(new LinearLayoutManager(getActivity(), LinearLayoutManager.VERTICAL, false));
        // folderRecyclerViewAdapter.setOnFolderClickListener(new OnFolderClickListener() {
//            @Override
//            public void itemClicked(String folderName) {
//
//            }
//        });
//    }

//    private void addListeners() {
//
//        // add listener to recyclerView
//        folderRecyclerViewAdapter.setOnFolderClickListener(new OnFolderClickListener() {
//            @Override
//            public void itemClicked(String folderName) {
//
//                if (item.getType().equals("note")) {
//                    //set noteFragment data
//                    final Bundle bundle = new Bundle();
//                    bundle.putString("title", item.getTitle());
//                    bundle.putString("bodyTxt", item.getDescription());
//                    bundle.putString("type", "noteDate");
//                    bundle.putString("noteDateType", item.getType());
//                    //change the fragment
//                    navController.navigate(R.id.action_archivedNoesListFragment_to_noteFragment3, bundle);
//                } else if (item.getType().equals("date")) {
//                    //set noteFragment data
//                    final Bundle bundle = new Bundle();
//                    bundle.putString("title", item.getTitle());
//                    bundle.putString("bodyTxt", item.getDescription());
//                    bundle.putString("type", "noteDate");
//                    bundle.putString("noteDateType", item.getType());
//                    //change the fragment
//                    navController.navigate(R.id.action_archivedNoesListFragment_to_noteFragment3, bundle);
//                }
//
//            }
//
//            @Override
//            public void onItemLongClicked(DateOrNote item) {
//                chosenDateOrNote = item;
//                customToolbarOption.setVisibility(View.VISIBLE);
//                customToolbarOption.hideRecycleBin();
//                customToolbarOption.hideFolder();
//                allNoteToolBar.setVisibility(View.GONE);
//            }
//        });
//
//        //add listener to custom toolbar option and set being archived or not to be saved in database
//        customToolbarOption.setCustomToolbarOptionListener(new CustomToolbarOptionListener() {
//            @Override
//            public void onStarClicked() {
//                customToolbarOption.setBlackStar();
//                myarchivedAdaptor.getDateOrNoteList().remove(chosenDateOrNote);
//                updateToUnarchiveInDataBase();
//                Toast.makeText(getContext(), "unarchived", Toast.LENGTH_SHORT).show();
//            }
//
//
//            @Override
//            public void onDeleteClicked() {
//            }
//
//            @Override
//            public void onCloseClicked() {
//                closeClicked(customToolbarOption);
//            }
//
//            @Override
//            public void onFolderClicked() {
//
//            }
//        });
//    }

    }
}